/*
 *      VID: [T1.2] PT: [Fri May 23 16:54:39 1997] SF: [platform.s]
 *       TI: [/sae_share/apps/bin/vice -iplatform.s -l// -p# -DEB164 -DSX164 -h -m -asx164 ]
 */
/*
*****************************************************************************
**                                                                          *
**  Copyright  1993, 1994						    *
**  by Digital Equipment Corporation, Maynard, Massachusetts.		    *
**                                                                          *
**  All Rights Reserved							    *
**                                                                          *
**  Permission  is  hereby  granted  to  use, copy, modify and distribute   *
**  this  software  and  its  documentation,  in  both  source  code  and   *
**  object  code  form,  and without fee, for the purpose of distribution   *
**  of this software  or  modifications  of this software within products   *
**  incorporating  an  integrated   circuit  implementing  Digital's  AXP   *
**  architecture,  regardless  of the  source of such integrated circuit,   *
**  provided that the  above copyright  notice and this permission notice   *
**  appear  in  all copies,  and  that  the  name  of  Digital  Equipment   *
**  Corporation  not  be  used  in advertising or publicity pertaining to   *
**  distribution of the  document  or  software without specific, written   *
**  prior permission.							    *
**                                                                          *
**  Digital  Equipment  Corporation   disclaims  all   warranties  and/or   *
**  guarantees  with  regard  to  this  software,  including  all implied   *
**  warranties of fitness for  a  particular purpose and merchantability,   *
**  and makes  no  representations  regarding  the use of, or the results   *
**  of the use of, the software and documentation in terms of correctness,  *
**  accuracy,  reliability,  currentness  or  otherwise;  and you rely on   *
**  the software, documentation and results solely at your own risk.	    *
**                                                                          *
**  AXP is a trademark of Digital Equipment Corporation.		    *
**                                                                          *
*****************************************************************************
**
**  FACILITY:	
**
**	DECchip 21164 PALcode
**
**  MODULE:
**
** 	platform.s
** 
**  MODULE DESCRIPTION:
** 
**	Machine specific OSF/1 PALcode for the DECchip 21164
** 
**  AUTHOR: Dick Bissen 
** 
**  CREATION-DATE: 16-Dec-1997
**
**  $Id: platform.s,v 1.27 1997/12/16 19:03:18 bissen Exp bissen $
** 
**  MODIFICATION HISTORY: 
**
**  $Log: platform.s,v $
**  Revision 1.1  1997/12/16  21:55:05  bissen
**  Initial revision
**
**
**-- 
*/
#if !defined(lint)
	.data
	.asciz "$Id: platform.s,v 1.1 1997/12/16 19:03:18 bissen Exp bissen $"
#endif

#include	"dc21164.h"	// DECchip 21164 specific definitions
#include	"osf.h"		// OSF/1 specific definitions
#include	"macros.h"	// Global macro definitions
#include	"impure.h"	// Scratch & logout area data structures
#include	"platform.h"	// Platform specific definitions
#include	"cserve.h"	// Cserve definitions


/*======================================================================*/
/*                     EXTERNAL ROUTINE DEFINITIONS                     */
/*======================================================================*/
	.global Sys_Reset
	.global Sys_ResetViaSwppal
	.global Sys_Interrupt
	.global Sys_IntMchkHandler
	.global	Sys_MchkLogOut
	.global Sys_EnterConsole
	.global	Sys_Cflush
	.global	Sys_Cserve
	.global	Sys_WrIpir
	.global Pal_End

	.global MchkCommon
	.global HaltDoubleMchk
	.global SaveState
	.global RestoreState
	.global CallPal_Rti

	.global Wr_Bcache
	.text	3

/*======================================================================*/
/*                   PLATFORM SPECIFIC INITIALIZATION                   */
/*======================================================================*/

	ALIGN_BLOCK

Sys_Reset:
#if defined(DEBUG)
	LEDWRITE(0xEB, t0, p7)
#endif

/*
**
** Create the internal IPL translation mask.
**
*/
	LDLI(t0,INT_K_MASK_HIGH)	// Load the upper longword of the mask.
	sll	t0, 32, t0		// Move into high end of quadword.
	LDLI(p7, INT_K_MASK_LOW)	// Load the lower longword of the mask.
	bis	t0, p7, t0		// Merge to create a quadword.
	mtpr	t0, ptIntMask		// Save in PALtemp.

#if defined(DISABLE_MACHINE_CHECKS)
/* RX164 */
/*
** Disable Machine Checks for now.  Machine Check handlers have
** not been setup yet.
**
** Call Wr_Bcache with the following arguments.
**      a0 (r16) - New BC_CONTROL value
**	a1 (r17) - BC_CONFIG value
**	a3 (r19) - MCR value
**	a4 (r20) - GTR value
**
**      v0 (r0)  - Cbox Base Address FF.FFF0.0000
**      p1 () - MCR Address
*/
	LDLI(p4, (BC_M_IO_PAR_ENA | BC_M_MEM_PAR_ENA))		// Load up Mck Bits.
	bic	t0, p4, a0				// Disable them for now.
	SAVE_SHADOW(a0,CNS_Q_BC_CFG2,p5)	// Save shadow of bcCfg2.

	ldah	v0, 0xFFF0(zero)	// v0 <- FFFF.FFFF.FFF0.0000
	zap	v0, 0xE0, v0		// Get base address of FF.FFF0.0000
	bis	t1, zero, a1		// Load up current BC_CONFIG

pvc$osf81$5080:
// RBB disable for now -	bsr	p6, Wr_Bcache		// Call cache-block-aligned routine
#endif /* DISABLE_MACHINE_CHECKS */

/*
**
** The SIO provides an ISA compatible interrupt controller which incorporates
** the functionality of two 82C59 interrupts controllers. The
** controllers are cascaded.
**
** We need to intialize the interrupt controller.
**
** INITIALIZATION COMMAND WORDS (ICW)
**
** Whenever a command is issued with A0=0 and D4=1, this is interpreted as
** Initialization Command Word 1 (ICW1).  ICW1 starts the initialization
** sequence.
** 
** INITIALIZATION COMMAND WORD 1 FORMAT (ICW1):
**
**   A0     D7  D6  D5  D4  D3  D2  D1  D0
** +---+  +---+---+---+---+---+---+---+---+
** | 0 |  | 0 | 0 | 0 | 1 | x | 0 | 0 | 1 |
** +---+  +---+---+---+---+---+---+---+---+
**                          ^   ^   ^   ^
**                          |   |   |   |
**                          |   |   |   +---- ICW4 needed 
**                          |   |   |
**                          |   |   +-------- Cascade mode
**                          |   |
**                          |   +------------ Call address interval of 8
**                          |
**                          +---------------- 0 = Edge triggered mode (INT2)
**                                            1 = Level triggered mode (INT1)
** 
** INITIALIZATION COMMAND WORD 2 FORMAT (ICW2):
**
**   A0     D7  D6  D5  D4  D3  D2  D1  D0
** +---+  +---+---+---+---+---+---+---+---+
** | 1 |  | 0 | 0 | 0 | 0 | 1 | 0 | 0 | 0 |
** +---+  +---+---+---+---+---+---+---+---+
**          ^   ^   ^   ^   ^
**          |   |   |   |   |
**          +---+---+---+---+---------------- T7 - T3 of interrupt vector byte
**
**
** INITIALIZATION COMMAND WORD 3 FORMAT (ICW3):
**
**   A0     D7  D6  D5  D4  D3  D2  D1  D0
** +---+  +---+---+---+---+---+---+---+---+
** | 1 |  | 0 | 0 | 0 | 0 | 0 | 1 | 1 | 0 |
** +---+  +---+---+---+---+---+---+---+---+
**                              ^   ^
**                              |   |
**                              |   +-------- Slave ID: 00110011 (INT2)
**                              |
**                              +------------ IRQ2 input has a slave (INT1)
*/

/* INITIALIZATION COMMAND WORD 4 FORMAT (ICW4):
**
**   A0     D7  D6  D5  D4  D3  D2  D1  D0
** +---+  +---+---+---+---+---+---+---+---+
** | 1 |  | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 1 |
** +---+  +---+---+---+---+---+---+---+---+
**                      ^   ^   ^   ^   ^
**                      |   |   |   |   |
**                      |   +-+-+   |   +---- 80C86/80C88 mode
**                      |     |     |
**                      |     |     +-------- Normal end of interrupt (EOI)
**                      |     |
**                      |     +-------------- Non-buffered mode
**                      |    
**                      +-------------------- Not special fully nested mode
**
** OPERATION CONTROL WORD 1 FORMAT (OCW1):
**
**   A0     D7  D6  D5  D4  D3  D2  D1  D0
** +---+  +---+---+---+---+---+---+---+---+
** | 1 |  | 1 | 1 | 1 | 1 | 1 | 1 | 1 | 1 |
** +---+  +---+---+---+---+---+---+---+---+
**          ^   ^   ^   ^   ^   ^   ^   ^
**          |   |   |   |   |   |   |   |
**          +---+---+---+---+---+---+---+---- Interrupt mask
**                                            All channels inhibited
**
** OPERATION CONTROL WORD 2 FORMAT (OCW2):
**
**   A0     D7  D6  D5  D4  D3  D2  D1  D0
** +---+  +---+---+---+---+---+---+---+---+
** | 1 |  | 0 | 0 | 1 | 0 | 0 | 0 | 0 | 0 |
** +---+  +---+---+---+---+---+---+---+---+
**          ^   ^   ^
**          |   |   |
**          +---+---+
**              |
**              +---------------------------- Non-specific EOI command
**
**
** See the SD164 Engineering Specification for information on memory 
** address bit definitions and encodings for accessing ISA I/O space.
**
*/

/*
** Initialize the 82C59A priority interrupt controller (PIC)
*/
	OutPortByte(PIC2_ICW1,0x11,t0,p7)
	OutPortByte(PIC2_ICW2,0x08,t0,p7)
	OutPortByte(PIC2_ICW3,0x02,t0,p7)
	OutPortByte(PIC2_ICW4,0x01,t0,p7)

	OutPortByte(PIC2_OCW1,0xFF,t0,p7)

	OutPortByte(PIC1_ICW1,0x11,t0,p7)
	OutPortByte(PIC1_ICW2,0x00,t0,p7)
	OutPortByte(PIC1_ICW3,0x04,t0,p7)
	OutPortByte(PIC1_ICW4,0x01,t0,p7)

	OutPortByte(PIC1_OCW1,0xFF,t0,p7)

/*
** Send -INTA pulses to clear any pending interrupts ...
*/
	IACK(t0,p7)

/*
** Finish writing the 82C59A PIC Operation Control Words ...
*/
	OutPortByte(PIC2_OCW2,0x20,t0,p7)
	OutPortByte(PIC1_OCW2,0x20,t0,p7)

#if 0
/* Initialize the real-time clock (RTC)
**
** Index into RTC Control Register A to set periodic interrupt rate
** to 976.562 and set it running.
*/

	OutPortByte(RTCADD,0x0A,t0,p7)
	OutPortByte(RTCDAT,0x26,t0,p7)

/*
** Index into RTC Control Register B and then enable periodic
** interrupts.
*/
	OutPortByte(RTCADD,0x0B,t0,p7)
	InPortByte(RTCDAT,v0,p7)
	lda     t0, 0x40(zero)          // Periodic interrupt bit
	bis     v0, t0, v0              // Merge it in

	OutPortByte(RTCADD,0x0B,t0,p7)
	OutPortByteReg(RTCDAT,v0,t0,p7)
#endif
#if defined(DISABLE_MACHINE_CHECKS)
/*
** Setup the Polaris PCICTL1 Register to disable System Machine Checks.
** They can be enabled after Machine check handlers have been setup.
*/
	lda	p7, LINEAR_CFG_BASE(zero)	// Form 9F.E000.0000
	sll	p7, 28, p7
	ldl_p	t0, PSC_PCICTLS(p7)		// Get PCI Control registers
	lda	t1, 1(zero)			// Get a 1
	sll	t1, 31, t1			// Bit 31 is set
	bic	t0, t1, t0			// OR in the bits
	stl_p	t0, PSC_PCICTLS(p7)		// Enable PSC errors
#endif /* DISABLE_MACHINE_CHECKS */
pvc$osf41$5010.1:
	ret	zero, (p5)		// Back to common reset flow...


/*
** We reset via a swppal. We need to load the internal IPL translation mask.
*/

Sys_ResetViaSwppal:
	LDLI(t0,INT_K_MASK_HIGH)	// Load the upper longword of the mask.
	sll	t0, 32, t0		// Move into high end of quadword.
	LDLI(p7,INT_K_MASK_LOW)	// Load the lower longword of the mask.
	bis	t0, p7, t0		// Merge to create a quadword.
	mtpr	t0, ptIntMask		// Save in PALtemp.
pvc$osf48$5060.1:
	ret	zero, (v0)		// Back to common ResetViaSwppal.

/*======================================================================*/
/*                 PLATFORM SPECIFIC INTERRUPT HANDLERS                 */
/*======================================================================*/


/*
** INPUT PARAMETERS:
**
**	p5 - Target IPL of highest priority pending interrupt
**	p7 - Interrupt summary
**
** Registers a0 .. a2, gp, ps, and pc saved on the kernel stack.
**
** OUTPUT PARAMETERS:
**
**	a0 - Interrupt entry type
**	a1 - Platform-specific interrupt vector
**	a2 - UNPREDICTABLE
**
** NOTE:
** The OSF/1 IPL and the internal IPL still need to be set!
*/
	ALIGN_BRANCH_TARGET
Sys_Interrupt:

	cmpeq	p5, 23, p4		// Is it a level 23 interrupt?
	bne	p4, Int23Handler

	cmpeq	p5, 22, p4		// Is it a level 22 interrupt?
	bne	p4, Int22Handler

	cmpeq	p5, 21, p4		// Is it a level 21 interrupt?
	bne	p4, Int21Handler

	cmpeq	p5, 20, p4		// Is it a level 20 interrupt?
	bne	p4, Int20Handler

	NOP				// Nothing there, so back out with rti.
	br	zero, CallPal_Rti

	ALIGN_BRANCH_TARGET
/*
** Int23 Handler
**
** On the EB164 PASS2, this interrupt is reserved. Just dismiss.
*/
Int23Handler:
	NOP
	br	zero, DismissInterrupt


	ALIGN_BRANCH_TARGET
/*
** Int22 Handler
**
** On the EB164, the Int22 Handler is for the Real Time Clock.
** We need to clear the interrupt, set up the ps, set up
** the a0-a1 paramters and post the interrupt.
**
** OUTPUT PARAMETERS:
** 	ps - IPL_K_CLK
**	a0 - Interrupt entry type = 1
**	a1 - UNPREDICTABLE
**	a2 - UNPREDICTABLE
**
** The RTC internal registers are accessed using two registers
** located in ISA I/O space:
**
**	RTCADD	0x70	RTC Address Register
**	RTCDAT	0x71	RTC Data Register
**
** On the first access, the address of the desired internal
** register is loaded, and on the second, the data are read
** or written.
*/
Int22Handler:

	mfpr	p4, ptIntMask		// Get the IPL translation mask.
	extbl	p4, IPL_K_CLK, p5	// Translate to internal IPL.

	bis	zero, IPL_K_CLK, ps	// Set the OSF/1 IPL.
	mtpr	p5, ipl			// Load the target IPL.

	mfpr	p4, ptEntInt		// Get pointer to kernel handler.

	OutPortByte(RTCADD,0x0C,p6,p7)	// Set up RTCADD to index register C.
	InPortByte(RTCDAT,p6,p7)	// Read to clear interrupt.
#if 1
	// this shouldn't hurt anything, but... :-\

	srl     p6, 6, p6               // Check for real interrupt.
	blbc    p6, DismissInterrupt    // Nope, just exit.
#endif

	mtpr	p4, excAddr		// Load kernel entry address.
	bis	zero, INT_K_CLK, a0	// Signal Real Time Clock interrupt.

	NOP
	NOP

	hw_rei

	ALIGN_BRANCH_TARGET
/*
** Int21 Handler
**
** IRQ1 - The 'or' of 17 PCI interrupts (IPL3)
**
**	Each of these interrupts can be individually masked by
**	writing to three mask registers at ISA addresses 804h, 805h
**	and 806h.
**
**	A read of these registers will return the state of the
**	17 PCI interrupts and not the state of the MASKED
**	interrupts. Thus it is necessary to know the mask values
**	to determine the real source. The PALcode will let the
**	OS handle all this.
**
**	So all we do it set a1 to 0x800 and a0 to 3 (device type)
**
** OUTPUT PARAMETERS:
** 	ps - IPL_K_DEV0 = 3
**	a0 - Interrupt entry type = 1
**	a1 - 0x800
*/
Int21Handler:
	mfpr	p4, ptIntMask		// Get the IPL translation mask.
	extbl	p4, IPL_K_DEV0, p5	// Translate to internal IPL.

	bis	zero, IPL_K_DEV0, ps	// Set the OSF/1 IPL.
	mtpr	p5, ipl			// Load the target IPL.

	mfpr	p4, ptEntInt		// Get pointer to kernel handler.
	lda	a1, 0x800(zero)		// Hardcode device interrupt for now

	mtpr	p4, excAddr		// Load kernel entry address
	bis	zero, INT_K_DEV, a0	// Signal I/O device interrupt

	NOP
	NOP

	hw_rei

	ALIGN_BRANCH_TARGET
/*
** Int20 Handler
**
** On the RX164, this interrupt is reserved. Just dismiss.
*/
Int20Handler:
	NOP
	br	zero, DismissInterrupt

	ALIGN_BRANCH_TARGET
/*
** Can't find the interrupt now. We have already stacked and made IPL
** and ps changes.
** Undo with call to rti.
*/

DismissInterrupt:
	NOP				// Nothing there, so back out with rti.
	br	zero, CallPal_Rti

/*======================================================================*/
/*     PLATFORM SPECIFIC INTERRUPT MACHINE CHECK HANDLER                */
/*======================================================================*/
/*
** FUNCTIONAL DESCRITPION:
**
**	The interrupt handler for system machine check stores
**	a code indicating system machine check error, loads
**	the System Control Block (SCB) vector for the
**	system machine check service routine, sets the
**	Machine-Check-In-Progress (MIP) flag in the Machine
**	Check Error Summary register (MCES), sets a flag indicating
**	that this is an interrupt-type machine check, and merges
**	with the common machine check flow.
**
**	If a second processor machine check error condition is 
**	detected while the MIP flag is set, the processor is 
**	forced into console I/O mode indicating "double error 
**	abort encountered" as the reason for the halt.
**
** OUTPUT PARAMETERS:
**
**	pt0		= saved v0
**	pt1		= saved t0
**	pt4		= saved t3
**	pt5		= saved t4
**	pt6		= saved t5
**	ptMisc<47:32>	= MCHK code with low bit set to indicate interrupt
**	ptMisc<31:16>	= SCB vector
**	ptMces<MIP>	= Set
**	p6 		= Cbox IPR base address
**
*/
	ALIGN_BRANCH_TARGET
/*
** On the EB164 PASS2, SIO NMI and CIA errors come into this machine check.
** For now, handle the SIO, and just leave the machine check as a general
** system hard error if not SIO.
*/
Sys_IntMchkHandler:
	InPortByte(SIO_NMISC,p4,p7)	// Get the NMI Status/Control bits.

	srl	p4, SIO_NMISC_V_SERR, p5	// Get SERR status bit in lsb.
	blbc	p5, 3f				// Not SERR, try IOCHK.
	srl	p4, SIO_NMISC_V_SERR_EN, p5	// Get SERR ena bit into lsb.
	blbs	p5, 3f				// SERR disabled, go try IOCHK.

	bis	p4, SIO_NMISC_M_SERR_EN, p5	// Set the SERR enable bit.
	and	p5, 0x0F, p5			// Clear status bits for write.

	OutPortByteReg(SIO_NMISC, p5, p6, p7)	// Clear source of interrupt.

	bis	zero, p4, p5			// Copy back original NMISC.
	and	p5, 0x0F, p5			// Clear status bits for write.

	OutPortByteReg(SIO_NMISC, p5, p6, p7)	// Write orig NMISC value.

	lda	p6, MCHK_K_SIO_SERR(zero)	// Denote as SIO SERR.
	br	zero, Sys_IntMchkHandlerMerge	// Turn into machine check.

	ALIGN_BRANCH_TARGET

3:	srl	p4, SIO_NMISC_V_IOCHK, p5	// Get IOCHK status into lsb.
	blbc	p5, 4f				// Not IOCHK.
	srl	p4, SIO_NMISC_V_IOCHK_EN, p5	// Get IOCHK ena bit into lsb.
	blbs	p5, 4f				// IOCHK disabled.

	bis	p4, SIO_NMISC_M_IOCHK_EN, p5	// Set the IOCHK enable bit.
	and	p5, 0x0F, p5			// Clear status bits for write.

	OutPortByteReg(SIO_NMISC, p5, p6, p7)	// Clear source of interrupt.

	bis	zero, p4, p5			// Copy back original NMISC.
	and	p5, 0x0F, p5			// Clear status bits for write.

	OutPortByteReg(SIO_NMISC, p5, p6, p7)	// Write NMISC contents.

	lda	p6, MCHK_K_SIO_IOCHK(zero)	// Denote as SIO IOCHK.
	br	zero, Sys_IntMchkHandlerMerge	// Turn into system mchk.

	ALIGN_BRANCH_TARGET
/*
** Polaris error. Don't think anything else comes in here. But for now
** just leave as a general system machine check.
*/
4:	lda	p6, MCHK_K_SYS_HERR(zero)	// Denote as CIA error.
	br	zero, Sys_IntMchkHandlerMerge	// Turn into machine check.

	ALIGN_BRANCH_TARGET
Sys_IntMchkHandlerMerge:
	mfpr	p4, excAddr		// Get exception address
	addq	p6, 1, p6		// Flag as interrupt

	sll	p6, PT16_V_MCHK, p6	// Shift MCHK code into upper longword
	mtpr	p4, pt10		// Save the exception address

	mfpr	p4, ptMces		// Get MCES and scratch bits

	mtpr	v0, pt0			// Save v0
	zap	p4, 0x3C, p4		// Isolate just MCES bits

	blbs	p4, HaltDoubleMchk	// Halt if MCHK already in progress

	bis	p4, p6, p4		// Combine MCES bits and MCHK code
	lda	p6, SCB_Q_SYSMCHK(zero)	// Get SCB vector

	sll	p6, PT16_V_SCB, p6	// Shift SCB vector into upper word

	bis	p4, p6, p6		// Combine SCB vector and MCHK bits

	bis	p6, MCES_M_MIP, p6	// Set Machine-Check-In-Progress flag

	mtpr	p6, ptMces		// Save combined SCB and MCHK bits

	ldah	p6, -0x10(zero)		// p6 <- FF...FFF0.0000
	mtpr	t0, pt1			// Save t0

	zap	p6, 0xE0, p6		// p6 <- FF.FFF0.0000 Cbox IPR base 
	mtpr	t3, pt4			// Save t3

	mtpr	t4, pt5			// Save t4

	mtpr	t5, pt6			// Save t6

	br	zero, MchkCommon	// Go join common machine flow ...


/*======================================================================*/
/*         PLATFORM SPECIFIC MACHINE CHECK LOGOUT                       */
/*======================================================================*/
/*
** Code to complete the platform-specific section of the MCHK 
** logout frame goes here ...
**
** Register Usage Conventions:
**
**	v0	Return address
**	t0	Scratch
**	t3	Scratch
**	t4	Scratch
**	t5	Scratch
**	p0	Scratch
**	p1	Scratch
**	p2	Scratch
**	p4	Scratch
**	p5	Scratch
**	p6	Base address of MCHK logout frame
**	p7	Scratch
**
**	pt0	Saved v0
**	pt1	Saved t0
**	pt4	Saved t3
**	pt5	Saved t4
**	pt6	Saved t5
**	pt10	Saved excAddr
**
*/
	ALIGN_BLOCK

Sys_MchkLogOut:

/*
** Code to complete the platform-specific section of the MCHK 
** logout frame goes here ...
*/
	LDLI(p5, LINEAR_CFG_BASE)	        // p5 <- 09FE
	sll	p5, 28, p5		                // p5 <- 9F.E000.0000

	ldl_p	p7, PSC_CMDSTAT(p5)		    // Read the PSC CMD/STAT register
	extwl	p7, 2, p7
	stq_p	p7, LAF_Q_PSC_STAT(p6)	    // Store it into Logout Frame

	ldl_p	p7, PSC_PCICTLS(p5)		// Read the PSC PCICTL0 register
	extbl	p7, 2, p7
	stq_p	p7, LAF_Q_PSC_PCICTL0(p6)	// Store it into Logout Frame

	ldl_p	p7, PSC_PCICTLS(p5)		        // Read the PSC PCICTL1 register
	extbl	p7, 3, p7
	stq_p	p7, LAF_Q_PSC_PCICTL1(p6)	// Store it into Logout Frame

	ldl_p	p7, PSC_PCICTL2(p5)		    // Read the PSC PCICTL2 register
	extbl	p7, 0, p7
	stq_p	p7, LAF_Q_PSC_PCICTL2(p6)	// Store it into Logout Frame
pvc$osf42$5050.1:
	ret	zero, (v0)		// Back to caller ...

/*======================================================================*/
/*                 PLATFORM SPECIFIC CALL_PAL FUNCTIONS                 */
/*======================================================================*/

	ALIGN_BLOCK

Sys_Cflush:
	hw_rei

	ALIGN_BLOCK

Sys_WrIpir:
	hw_rei


/*
**
** FUNCTIONAL DESCRIPTION:
**
**	The console service (cserve) function implements console and
**	platform specific operations.
**
** CALLING SEQUENCE:
**
**	Branched into from the CALL_PAL cserve entry point.
**
** INPUT PARAMETERS:
**
**	a0 - function parameter
**	a1 - function parameter
**	a2 - function type
**
** OUTPUT PARAMETERS:
**
**	v0 - function result
**
** SIDE EFFECTS:
**	
*/
	ALIGN_BLOCK

Sys_Cserve:

	cmpeq	a2, CSERVE_K_LDQP, v0
	bne	v0, Sys_Cserve_Ldqp

	cmpeq	a2, CSERVE_K_STQP, v0
	bne	v0, Sys_Cserve_Stqp

	cmpeq	a2, CSERVE_K_JTOPAL, v0
	bne	v0, Sys_Cserve_Jtopal

	cmpeq	a2, CSERVE_K_WR_INT, v0
	bne	v0, Sys_Cserve_Wr_Int

	cmpeq	a2, CSERVE_K_RD_IMPURE, v0
	bne	v0, Sys_Cserve_Rd_Impure

	cmpeq	a2, CSERVE_K_PUTC, v0
	bne	v0, Sys_Cserve_Putc

	cmpeq	a2, CSERVE_K_WR_ICSR, v0
	bne	v0, Sys_Cserve_Wr_Icsr

	cmpeq	a2, CSERVE_K_RD_ICSR, v0
	bne	v0, Sys_Cserve_Rd_Icsr

	cmpeq	a2, CSERVE_K_RD_BCCFG2, v0
	bne	v0, Sys_Cserve_Rd_bcCfg2

	cmpeq	a2, CSERVE_K_RD_BCCFG, v0
	bne	v0, Sys_Cserve_Rd_BcCfg

	cmpeq	a2, CSERVE_K_WR_BCACHE, v0
	bne	v0, Sys_Cserve_Wr_Bcache

	cmpeq	a2, CSERVE_K_RD_BCCFG_OFF, v0
	bne	v0, Sys_Cserve_Rd_BcCfgOff
#if defined(SROM_SERIAL_PORT)
	cmpeq	a2, CSERVE_K_SROM_INIT, v0
	bne	v0, Sys_Cserve_Srom_Init

	cmpeq	a2, CSERVE_K_SROM_PUTC, v0
	bne	v0, Sys_Cserve_Srom_Putc

	cmpeq	a2, CSERVE_K_SROM_GETC, v0
	bne	v0, Sys_Cserve_Srom_Getc
#endif /* SROM_SERIAL_PORT */

	cmpeq	a2, CSERVE_K_RD_MAF_MODE, v0
	bne	v0, Sys_Cserve_Rd_MafMode

	cmpeq	a2, CSERVE_K_WR_MAF_MODE, v0
	bne	v0, Sys_Cserve_Wr_MafMode

	hw_rei                          // If none, just return ...

/*
**
** FUNCTIONAL DESCRIPTION:
**
**	Load (physical) quadword from memory to register v0.
**
** INPUT PARAMETERS:
**
**      a0 (r16) - Physical address
**
** OUTPUT PARAMETERS:
**
**	v0 (r0)  - Returned data
**
** SIDE EFFECTS:
**	
*/
	ALIGN_BRANCH_TARGET

Sys_Cserve_Ldqp:
	ldq_p	v0, 0(a0)
	hw_rei

/*
**
** FUNCTIONAL DESCRIPTION:
**
**	Store (physical) quadword from register a1 to memory.
**
** INPUT PARAMETERS:
**
**      a0 (r16) - Physical address
**      a1 (r17) - Data to be written
**
** OUTPUT PARAMETERS:
**
**	None
**
** SIDE EFFECTS:
**	
*/
	ALIGN_BRANCH_TARGET

Sys_Cserve_Stqp:
	stq_p	a1, 0(a0)
	hw_rei

/*
**
** FUNCTIONAL DESCRIPTION:
**
**	Transfer control to the specified address, passed in 
**      register a0, in PAL mode.
**
** INPUT PARAMETERS:
**
**      a0 (r16) - Transfer address
**
** OUTPUT PARAMETERS:
**
**   DECchip 21064 specific parameters:
**   
**      t0 (r1)  - bcCtl	DC21164
**      t0 (r1)  - bcCfg2	DC21164PC
**      t1 (r2)  - bcCfg
**
**   Firmware specific parameters:
**
**	s6 (r15) - Encoded srom.s RCS revision
**	a0 (r16) - Processor identification (a la SRM)
**      a1 (r17) - Size of good memory in bytes
**      a2 (r18) - Cycle count in picoseconds
**      a3 (r19) - Protocol signature and system revision
**      a4 (r20) - Active processor mask
**      a5 (r21) - System Context value
**
** SIDE EFFECTS:
**
*/
	ALIGN_BRANCH_TARGET

Sys_Cserve_Jtopal:
	bic	a0, 3, t8		// Clear out low 2 bits of address
	bis	t8, 1, t8		// Or in PAL mode bit

	mfpr	t9, ptImpure		// Get base of impure scratch area.
        lda     t9, CNS_Q_IPR(t9)    	// Point to start of IPR area.

	RESTORE_SHADOW(a3,CNS_Q_SIGNATURE,t9)	// Get signature.
        srl     a3, 16, t0              // Shift signature into lower word.
	zap	t0, 0xFC, t0		// Ignore the upper longword.
	LDLI(t10,0xDECB)		// Load the expected valid signature.

        cmpeq   t0, t10, t0		// Check if saved signature was valid.
        blbc    t0, 1f                  // If invalid, pass nothing.
/*
** Load the processor specific parameters ...
*/
	RESTORE_SHADOW(t0,CNS_Q_BC_CFG2,t9)	// Get bcCfg2.
	
	RESTORE_SHADOW(t1,CNS_Q_BC_CFG,t9)	// Get bcCfg.
	RESTORE_SHADOW(t2,CNS_Q_BC_CFG_OFF,t9)	// Get bcCfg.
/*
** Load the firmware specific parameters ...
*/
	RESTORE_SHADOW(s6,CNS_Q_SROM_REV,t9)	// Get srom revision.
	RESTORE_SHADOW(a0,CNS_Q_PROC_ID,t9)	// Get processor id.
	RESTORE_SHADOW(a1,CNS_Q_MEM_SIZE,t9)	// Get memory size.
	RESTORE_SHADOW(a2,CNS_Q_CYCLE_CNT,t9)	// Get cycle count.
	RESTORE_SHADOW(a4,CNS_Q_PROC_MASK,t9)	// Get processor mask.
	RESTORE_SHADOW(a5,CNS_Q_SYSCTX,t9)	// Get system context.

	STALL
	STALL

1:	mtpr	zero, ptWhami		// Clear WHAMI and swap flag.
	mtpr	t8, excAddr		// Load the dispatch address.
	br	zero, 2f

	ALIGN_BLOCK

2:	NOP
	mtpr	zero, icFlush		// Flush the icache.
	NOP
	NOP

	NOP                           // Required NOPs ... 1-10
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP

	NOP                           // Required NOPs ... 11-20
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP

	NOP                           // Required NOPs ... 21-30
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP

	NOP                           // Required NOPs ... 31-40
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP



	NOP				// Required NOPs ... 41-44
	NOP
	NOP
	NOP

	hw_rei				// Dispatch in PAL mode ...

/*
**
** FUNCTIONAL DESCRIPTION:
**
**	Write the Interrupt Map Register
**
** INPUT PARAMETERS:
**
**      a0 (r16) - New map value
**
** OUTPUT PARAMETERS:
**
**	None
**
** SIDE EFFECTS:
**
*/
	ALIGN_BRANCH_TARGET

Sys_Cserve_Wr_Int:
	mtpr	a0, ptIntMask		// Write new interrupt map

	STALL
	STALL

	hw_rei

/*
**
** FUNCTIONAL DESCRIPTION:
**
**	Return the base address of the PAL impure scratch
**      area in register v0 (r0).
**
** INPUT PARAMETERS:
**
**      None
**
** OUTPUT PARAMETERS:
**
**	v0 (r0) - Returned base address of impure scratch area.
**
** SIDE EFFECTS:
**
*/
	ALIGN_BRANCH_TARGET

Sys_Cserve_Rd_Impure:
	mfpr	v0, ptImpure		// Get base of impure scratch area.
	hw_rei

/*
**
** FUNCTIONAL DESCRIPTION:
**
**      Output a character to the serial port.
**
** INPUT PARAMETERS:
**
**      a0 (r16) - Character
**
** OUTPUT PARAMETERS:
**
**	v0 (r0) - Return status
**
** SIDE EFFECTS:
**
*/
	ALIGN_BRANCH_TARGET

Sys_Cserve_Putc:

	InPortByte(COM1_LSR,p0,p7)

	srl     p0, LSR_V_THRE,p0
	blbc    p0, Sys_Cserve_Putc

	OutPortByteReg(COM1_THR,a0,p0,v0)

	lda     v0, 1(zero)
	hw_rei

/*
**	Return the MAF_MODE Register
**      register v0 (r0).
**
** INPUT PARAMETERS:
**
**      None
**
** OUTPUT PARAMETERS:
**
**	v0 (r0) - Returned MAF_MODE value
**
** SIDE EFFECTS:
**
*/
	ALIGN_BRANCH_TARGET

Sys_Cserve_Rd_MafMode:
        mfpr	v0, mafMode			// Read MAF_MODE.
	hw_rei

/*
**
** FUNCTIONAL DESCRIPTION:
**
**	Write the Miss Address Mode Register (MAF_MODE) IPR.
**
** INPUT PARAMETERS:
**
**      a0 (r16) - New MAF_MODE value
**
** OUTPUT PARAMETERS:
**
**	None
**
** SIDE EFFECTS:
**
*/

	ALIGN_BRANCH_TARGET

Sys_Cserve_Wr_MafMode:
	mtpr	a0, mafMode		// Write MAF_MODE

	STALL                           // Required stall to update chip ...
    STALL
	STALL
	STALL
	STALL

	hw_rei


/*
**
** FUNCTIONAL DESCRIPTION:
**
**	Return the Ibox Control/Status Register (ICSR) IPR
**      register v0 (r0).
**
** INPUT PARAMETERS:
**
**      None
**
** OUTPUT PARAMETERS:
**
**	v0 (r0) - Returned ICSR value
**
** SIDE EFFECTS:
**
*/
	ALIGN_BRANCH_TARGET

Sys_Cserve_Rd_Icsr:
        mfpr	v0, icsr			// Read IPR.
	hw_rei

/*
**
** FUNCTIONAL DESCRIPTION:
**
**	Write the Ibox Control/Status Register (ICSR) IPR. The
**	user is not allowed to affect SPE or SDE.
**
** INPUT PARAMETERS:
**
**      a0 (r16) - New ICSR value
**
** OUTPUT PARAMETERS:
**
**	None
**
** SIDE EFFECTS:
**
*/

#define ICSR_K_MASK \
	((1<<(ICSR_V_SDE-16)) | \
	 (2<<(ICSR_V_SPE-16)))

	ALIGN_BRANCH_TARGET

Sys_Cserve_Wr_Icsr:
	ldah	p0, ICSR_K_MASK(zero)	// Disallow affecting SPE, SDE
	bis	a0, p0, p0		// Force SPE, SDE
	
	mtpr	p0, icsr		// Write ICSR

	STALL                           // Required stall to update chip ...
        STALL
	STALL
	STALL
	STALL

	hw_rei

/*
**
** FUNCTIONAL DESCRIPTION:
**
**	Return the shadow copy of the BC_CONFIG2 IPR in 
**      register v0 (r0).
**
** INPUT PARAMETERS:
**
**      None
**
** OUTPUT PARAMETERS:
**
**	v0 (r0) - Returned BC_CONFIG2 value
**
** SIDE EFFECTS:
**
*/
	ALIGN_BRANCH_TARGET

Sys_Cserve_Rd_bcCfg2:
	mfpr	p0, ptImpure            // Get base of impure scratch area
	lda	p0, CNS_Q_IPR(p0)	// Point to base of IPR area.

	RESTORE_SHADOW(v0,CNS_Q_BC_CFG2,p0)	// Get shadow copy.

	STALL

	hw_rei

/*
**
** FUNCTIONAL DESCRIPTION:
**
**	Return the shadow copy of the BC_CONFIG IPR in 
**      register v0 (r0).
**
** INPUT PARAMETERS:
**
**      None
**
** OUTPUT PARAMETERS:
**
**	v0 (r0) - Returned BC_CONFIG value
**
** SIDE EFFECTS:
**
*/
	ALIGN_BRANCH_TARGET

Sys_Cserve_Rd_BcCfg:
	mfpr	p0, ptImpure            // Get base of impure scratch area
	lda	p0, CNS_Q_IPR(p0)	// Point to base of IPR area.

	RESTORE_SHADOW(v0,CNS_Q_BC_CFG,p0)	// Get shadow copy.

	STALL

	hw_rei


/*
**
** FUNCTIONAL DESCRIPTION:
**
**	Return the shadow copy of the BC_CFG_OFF in 
**      register v0 (r0).
**
** INPUT PARAMETERS:
**
**      None
**
** OUTPUT PARAMETERS:
**
**	v0 (r0) - Returned BC_CFG_OFF value
**
** SIDE EFFECTS:
**
*/
	ALIGN_BRANCH_TARGET

Sys_Cserve_Rd_BcCfgOff:
	mfpr	p0, ptImpure            // Get base of impure scratch area
	lda	p0, CNS_Q_IPR(p0)	// Point to base of IPR area.

	RESTORE_SHADOW(v0,CNS_Q_BC_CFG_OFF,p0)	// Get shadow copy.

	STALL

	hw_rei


/*
**
** FUNCTIONAL DESCRIPTION:
**
**	Write BC_CONTROL IPR and the shadow copy,
**	and write BC_CONFIG and the shadow copy.
**	Write CIA CSR CACK_EN and Memory Control
**	Register MCR.
**
** INPUT PARAMETERS:
**
**  a0 (r16) - New BC_CONTROL value
**	a1 (r17) - New BC_CONFIG value
**	a3 (r19) - New MCR value
**
** OUTPUT PARAMETERS:
**
**	v0 (r0) - 1 for success
**
** SIDE EFFECTS:
**
*/
	ALIGN_BRANCH_TARGET

Sys_Cserve_Wr_Bcache:
	ldah	v0, -0x10(zero)		// v0 <- FFFF.FFFF.FFF0.0000
	zap	v0, 0xE0, v0		// Get base address of FF.FFF0.0000

	lda	p0, 1(zero)		// Get a 1
	sll	p0, 39, p0		// Place in bit 39

pvc$osf80$5080:
	bsr	p6, Wr_Bcache		// Call cache-block-aligned routine

	mfpr	p0, ptImpure            // Get base of impure scratch area
	lda	p0, CNS_Q_IPR(p0)	// Point to base of IPR area

	SAVE_SHADOW(a0,CNS_Q_BC_CFG2,p0)	// Save shadow copy
	SAVE_SHADOW(a1,CNS_Q_BC_CFG,p0)	// Save shadow copy

	bis	zero, 1, v0		// Mark success

	STALL
	STALL

	hw_rei

/*
** This subroutine does writes. The write must be preceded by MB,
** followed by MB, and have no concurrent cacheable Istream references.
** So we loop a while to let the Istream settle out, and then work
** the branches to avoid Istream read misses.
*/
	ALIGN_BLOCK

Wr_Bcache:
	NOP
	NOP
	lda	p4, 100(zero)		// Get Istream prefetches to settle out
1:	subq	p4, 1, p4		// Decrement the counter

	bgt	p4, 2f			// Skip the write for many iterations
	mb
	stq_p	a0, bcCfg2(v0)		// Write the control
	mb

2:	bgt	p4, 3f
	stq_p	a1, bcCfg(v0)	// Write the configuration
	mb
	bis		a3, a3, a3		// noop
	mb
	bis		a3, a3, a3

3:	bgt	p4, 4f
	mb
	bis 	a4, a4, a4		// noop
	mb
	bis		a4, a4, a4		// noop

4:	bgt	p4, 1b			// The Ibox will predict as taken
					// and will hit in the Icache,
					// so will won't get a read miss
pvc$osf80$5080.1:
	ret	zero, (p6)		// We're done, so return


/*======================================================================*/
/*                 PLATFORM SPECIFIC CONSOLE FUNCTIONS                  */
/*======================================================================*/
/*
**
** FUNCTIONAL DESCRIPTION:
**
**	Save the current machine state and enter
**	console I/O mode.
** 
**	**********************************************************
**	***                                                    ***
**	*** This routine is specifically tailored for use with ***
**	*** Debug Monitor on the DECchip Evaluation Boards.    ***
**	***                                                    ***
**	**********************************************************
**
** CALLING SEQUENCE:
** 
**	Called by PALcode as a result of a HALT, 
**	hard reset, or catastrophic error.
** 
** INPUT PARAMETERS:
** 
**	r0 (v0) = reason for halt
**
**	pt0	= Saved r0
** 
** OUTPUT PARAMETERS:
**
**	None
** 
** SIDE EFFECTS:
**
** 
*/ 
	ALIGN_BLOCK
	
Sys_EnterConsole:
	mtpr	t0, pt4			// Save t0
	mtpr	t2, pt5			// Save t2

#if defined(DEBUG)
	LEDWRITE(0xEA, t0, t2)
#endif

	mfpr	t0, ptImpure		// Get pointer to impure scratch area

pvc$osf43$5020:
	bsr	t2, SaveState		// Save the state of the world ...

	mfpr	t0, ptPtbr		// Get the physical page table base.
	bis	t0, 1, t0		// Enable physical mode translation.
	mtpr	t0, ptPtbr		// Update the chip.

	LDLI	(sp,0x00FFE000)		// Initialize the kernel stack pointer.

	mtpr	sp, ptKsp		// Update the saved KSP value.

	lda	ps, IPL_K_HIGH(zero)	// Set PS shadow - Kernel mode, IPL=7
	lda	t0, 0x1F(zero)		// Set internal IPL=1F
	mtpr	t0, ipl
	mtpr	zero, ips		// Set Ibox mode to kernel
	mtpr	zero, dtbCm		// Set Mbox mode to kernel

	mtpr	zero, dtbIa		// Flush the DTB
	mtpr	zero, itbIa		// Flush the ITB
	mtpr	zero, astrr		// Clear all ASTs ...
	mtpr	zero, aster
	mtpr	zero, sirr		// Clear all software interrupts.

	br	t0, 1f			// Branch over static data.
	.long	CONSOLE_ENTRY
1:	ldl_p	t0, 0(t0)		// Get the transfer address.
	mtpr	t0, excAddr		// Load console entry point.
	mfpr	t0, pt4			// Restore scratch registers.
	mfpr	t2, pt5
	bis	v0, v0, t0		// Move halt code to t0.

	hw_rei_stall			// Transfer to console I/O mode ...

/*
** The Pal_End label must be preceeded by any
** the text and data segments.
*/
	.data
Pal_End:













